{$M 65000,0,655360}

program triplete_steiner;
uses crt;
var n:integer;
    numar,i1,j1,k1:integer;
    a:array[1..100,1..100] of boolean;
    f:text;
    solutie:boolean;

procedure noua;
 begin
  assign(f,'steiner.txt');
  rewrite(f);
  writeln(f,'57');
  writeln(f,'11 13 18');
  writeln(f,'11 12 19');
  writeln(f,'10 13 19');
  writeln(f,'10 12 18');
  writeln(f,'9 15 16');
  writeln(f,'9 14 17');
  writeln(f,'8 15 17');
  writeln(f,'8 14 16');
  writeln(f,'7 13 16');
  writeln(f,'7 12 17');
  writeln(f,'7 11 14');
  writeln(f,'7 10 15');
  writeln(f,'7 9 18');
  writeln(f,'7 8 19');
  writeln(f,'6 13 17');
  writeln(f,'6 12 16');
  writeln(f,'6 11 15');
  writeln(f,'6 10 14');
  writeln(f,'6 9 19');
  writeln(f,'6 8 18');
  writeln(f,'5 15 18');
  writeln(f,'5 14 19');
  writeln(f,'5 11 16');
  writeln(f,'5 10 17');
  writeln(f,'5 9 12');
  writeln(f,'5 8 13');
  writeln(f,'4 15 19');
  writeln(f,'4 14 18');
  writeln(f,'4 11 17');
  writeln(f,'4 10 16');
  writeln(f,'4 9 13');
  writeln(f,'4 8 12');
  writeln(f,'3 17 18');
  writeln(f,'3 16 19');
  writeln(f,'3 13 14');
  writeln(f,'3 12 15');
  writeln(f,'3 9 10');
  writeln(f,'3 8 11');
  writeln(f,'3 5 6');
  writeln(f,'3 4 7');
  writeln(f,'2 17 19');
  writeln(f,'2 16 18');
  writeln(f,'2 13 15');
  writeln(f,'2 12 14');
  writeln(f,'2 9 11');
  writeln(f,'2 8 10');
  writeln(f,'2 5 7');
  writeln(f,'2 4 6');
  writeln(f,'1 18 19');
  writeln(f,'1 16 17');
  writeln(f,'1 14 15');
  writeln(f,'1 12 13');
  writeln(f,'1 10 11');
  writeln(f,'1 8 9');
  writeln(f,'1 6 7');
  writeln(f,'1 4 5');
  writeln(f,'1 2 3');
  close(f);
  halt;
 end;


function curat:boolean;
 var i,j:integer;
     cor:boolean;
 begin
  cor:=true;
  for i:=1 to n-1 do
   for j:=i+1 to n do
    cor:=cor and a[i,j];
  curat:=cor;
 end;

function verifica(i,j,k:integer):boolean;
 begin
  verifica:= not(a[i,j]) and not(a[j,k]) and not(a[k,i]);
 end;

function cauta(x,y,z:integer; var i,j,k:integer):boolean;
 label 10;
 var i1,j1,k1,pz:integer;
 begin
  for i1:=1 to n-1 do
   for j1:=i1+1 to n do
    if not(a[i1,j1]) then begin
                           pz:=i1;
                           i1:=n-1;
                           j1:=n;
                          end;
  i1:=pz;
  if i1=x then for j1:=y to n-1 do
                 begin
                  if j1=y then begin
                               for k1:=z to n do
                                if verifica(i1,j1,k1) then goto 10
                              end
                         else begin
                               for k1:=j1+1 to n do
                                if verifica(i1,j1,k1) then goto 10
                              end
                 end
          else for j1:=i1+1 to n-1 do
                for k1:=j1+1 to n do
                 if verifica(i1,j1,k1) then goto 10;
 10: i:=i1;j:=j1;k:=k1;
 cauta:=verifica(i1,j1,k1);
end;


procedure back(i1,j1,k1,pz:integer);
 var i,j,k:integer;
     gasit:boolean;
 begin
  if pz>numar then solutie:=true
              else begin
                  gasit:=cauta(i1,j1,k1,i,j,k);
                  while gasit and not(solutie) do
                     begin
                      a[i,j]:=true;
                      a[j,i]:=true;
                      a[i,k]:=true;
                      a[k,i]:=true;
                      a[j,k]:=true;
                      a[k,j]:=true;
                      back(i,j,k+1,pz+1);
                      if solutie then writeln(f,i,' ',j,' ',k);
                      a[i,j]:=false;
                      a[j,i]:=false;
                      a[i,k]:=false;
                      a[k,i]:=false;
                      a[j,k]:=false;
                      a[k,j]:=false;
                      gasit:=cauta(i,j,k+1,i1,j1,k1);
                      i:=i1;j:=j1;k:=k1;
                     end;
                  end;
 end;

procedure error;
 var f:text;
 begin
  assign(f,'steiner.txt');
  rewrite(f);
  writeln(f,0);
  close(f);
  halt;
 end;

procedure citire;
 var f:text;
 begin
  assign(f,'n.txt');
  reset(f);
  readln(f,n);
  close(f);
  if n mod 2 = 0 then error;
  if n*(n-1) mod 6 <> 0 then error;
  if n=19 then noua;
 end;

procedure calcul;
 var i:integer;
 begin
  assign(f,'steiner.txt');
  rewrite(f);
  writeln(f,numar);
  fillchar(a,sizeof(a),false);
  for i:=1 to n do a[i,i]:=true;
  back(1,2,3,1);
  close(f);
 end;

begin
 clrscr;
 citire;
 numar := (n-1)*n div 6;
 solutie:=false;
 calcul;
end.