#include <stdio.h>
#include <stdlib.h>
void citire(void);
void determinare(void);
void afisare(void);
int nivele[2000];
struct nod
{
	int val,nec,tata,dr,stg;
};
nod a[2000];
int n,nr;
void eroare(char *s)
{
	puts(s);
	exit(1);
}
FILE *f,*g;
void main(void)
{
	f=fopen("arbore.in","rt");
	g=fopen("arbore.out","wt");
	if (!f || !g) eroare("File not found.");
	while (1)
	{
		citire();
		determinare();
	}
}
void citire(void)
{
	fscanf(f,"%d",&n);
	if (!n) fclose(f),fclose(g),exit(1);
	for (int i=0;i<n;i++)
	{
		fscanf(f,"%d",&a[i].nec);
		a[i].val=1;
		a[i].tata=-1;
		a[i].stg=a[i].dr=-1;
	}
	nr=n;
}
void determinare(void)
{
	int i;
	i=0;
	int ind;
	if (a[n-1].nec!=n)
	{
		fprintf(g,"SPECIE NECUNOSCUTA DE ARBORE.\n\n");
		return;
	}
	while (a[0].val!=n)
	{
		if (a[0].nec!=a[0].val)
		{
			fprintf(g,"SPECIE NECUNOSCUTA DE ARBORE.\n\n");
			return;
		}
		ind=i=0;
		while (a[i].nec==a[i].val || a[i].tata!=-1)
		{
			if(a[i].tata<0) ind=i;
			i++;
		}
		a[nr]=a[ind];
		a[ind].tata=-1;
		a[ind].val+=a[i].val;
		a[ind].stg=nr;
		a[ind].dr=i;
		a[ind].nec=a[i].nec;
		a[i].tata=ind;
		//a[i].val=a[i].nec;
		a[nr].tata=ind;
		nr++;
	}
	afisare();
}
void pune(int n,int niv)
{
	for (int i=1;i<niv;i++)
	{
		if (nivele[i]) fprintf(g," ");
		else fprintf(g,"  ");
	}
	nivele[niv]=!nivele[niv];
	if (!n) fprintf(g,"%d\n",a[0].val);
	else
	if (nivele[niv]) fprintf(g,"-%d\n",a[n].val);
	else fprintf(g,"-%d\n",a[n].val);
	if (a[n].dr!=-1)
	{	pune(a[n].stg,niv+1);
		pune(a[n].dr,niv+1);
	}
}
void afisare(void)
{
	for (int i=0;i<nr;i++) nivele[i]=0;
	pune(0,0);
	fprintf(g,"\n");
}
