{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 65384,0,655360}

program ActivInactiv;

   uses Crt;

   var a:array[0..199,0..199]of byte;
       max,l,niv,fii,taie:array[1..200]of byte;
       f:text;
       drum:array[1..1000]of byte;
       n,prim,ld:byte;

procedure ReadData;
   var i,j,k:byte;
   begin
     assign(f,'input.txt');
     reset(f);
     readln(f,n);
     for k:=1 to n-1 do
      begin
       readln(f,i,j);
       inc(a[j,0]);
       a[j,a[j,0]]:=i;
       {inc(a[i,0]);
       a[i,a[i,0]]:=j;}
      end;
     readln(f,prim);
     close(f);
     for i:=1 to n do for j:=1 to a[i,0] do
      begin
       inc(niv[a[i,j]]);
       a[a[i,j],a[a[i,j],0]+niv[a[i,j]]]:=i;
      end;
   end;

procedure Sort(ll,r:integer);
var
  i, j, x, y: integer;
begin
  i := ll; j := r; x := l[(ll+r) DIV 2];
  repeat
    while l[i] < x do i := i + 1;
    while x < l[j] do j := j - 1;
    if i <= j then
    begin
      y := l[i]; l[i] := l[j]; l[j] := y;
      y:=max[i]; max[i]:=max[j]; max[j]:=y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if ll < j then Sort(ll, j);
  if i < r then Sort(i, r);
end;


procedure Sorta(ll,r:byte);
var
  i, j, x, y: integer;
begin
  i := ll; j := r;
  x := max[fii[(ll+r) DIV 2]];
  repeat
    while max[fii[i]] < x do i := i + 1;
    while x < max[fii[j]] do j := j - 1;
    if i <= j then
    begin
      y := fii[i]; fii[i] := fii[j]; fii[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if ll < j then Sort(ll, j);
  if i < r then Sort(i, r);
end;


procedure Drumul;
   var i,j,k:byte;
       sw:boolean;
   begin
     for i:=1 to n do max[i]:=i;
     l[prim]:=1;
     sw:=true;
     while sw do
      begin
        sw:=false;
        for i:=1 to n do if l[i]>0 then
         begin
          for j:=1 to a[i,0]+niv[i] do if l[a[i,j]]=0 then
           begin l[a[i,j]]:=l[i]+1; sw:=true; end;
         end;
      end;
     sort(1,n);
     l:=max;
   end;

procedure LDrumul;
   var i,j,k,nrfii:integer;
       taiate:set of byte;
   begin
    ld:=0;
    taiate:=[prim];
    drum[1]:=a[prim,1];
    taie[1]:=prim;
    k:=a[prim,1];
    ld:=1;
    while ld<max[prim] do
     begin
       nrfii:=0;
       for i:=1 to a[k,0]+niv[k] do if not(a[k,i] in taiate) then
        begin inc(nrfii); fii[nrfii]:=a[k,i]; end;
       Sorta(1,nrfii);
       inc(ld);
       drum[ld]:=fii[nrfii];
       max[drum[ld-1]]:=0;
       k:=drum[ld];
       nrfii:=0;
       for i:=1 to a[k,0] do if not(a[k,i] in taiate) then
        begin inc(nrfii); fii[nrfii]:=a[k,i]; end;
       if nrfii>0 then sorta(1,nrfii);
       if nrfii=0 then taie[ld]:=0 else taie[ld]:=fii[1];
       taiate:=taiate+[taie[ld]];
     end;
    assign(f,'output.txt');
    rewrite(f);
    writeln(f,max[prim]);
    for i:=1 to ld  do write(f,drum[i],' ');
    writeln(f);
    for i:=1 to ld do write(f,taie[i],' ');
    close(f);
   end;


procedure CalculezCosturile;
   var i,j,laux,succ,nrfii:byte;
       aux:array[1..200]of byte;
   begin
     fillchar(max,sizeof(max),0);
     aux[1]:=prim;
     i:=prim;
     laux:=1;
     while niv[i]<>0 do
      begin inc(laux); aux[laux]:=a[i,a[i,0]+1]; i:=aux[laux]; end;
     for i:=n downto 2 do
      begin
       if (a[l[i],0]=0) then max[l[i]]:=2 else
        begin
         succ:=a[l[i],a[l[i],0]+1];
         for j:=2 to laux do if aux[j]=l[i] then succ:=aux[j-1];
         nrfii:=0;
         if (succ<>a[l[i],a[l[i],0]+1])
         and(a[l[i],a[l[i],0]+1]<>0) then max[l[i]]:=1+max[a[l[i],a[l[i],0]+1]];
         for j:=1 to a[l[i],0] do if a[l[i],j]<>succ then
          begin inc(nrfii); fii[nrfii]:=a[l[i],j]; end;
         sorta(1,nrfii);
         for j:=nrfii downto (nrfii div 2)+1 do max[l[i]]:=max[l[i]]+max[fii[j]];
        end;
      end;
      max[prim]:=1+max[aux[2]];
   end;



begin
 ReadData;
 Drumul;
 CalculezCosturile;
 LDrumul;
end.