{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$M 65520,0,655360}
const
	fis_in='n.txt';
  fis_out='steiner.txt';

var
	n: integer;
  kmin: integer;
  v: array[1..100, 1..100] of integer;
  triple: array[1..4000] of record
    a,b,c: integer;
  	end;
  xx: array[1..100] of integer;
  virf: integer;
  b: boolean;

function gaseste(nxt: integer): boolean;
var
	i,j,k: integer;
begin
  for i:=1 to n do
	  for j:=i+1 to n do
    if v[i,j]=0 then
		  for k:=j+1 to n do
      if (v[j,k]=0) and (v[i,k]=0) then
      begin
				triple[nxt].a:=i;
				triple[nxt].b:=j;
				triple[nxt].c:=k;
        v[i,j]:=nxt;
        v[j,i]:=nxt;
        v[j,k]:=nxt;
        v[k,j]:=nxt;
        v[i,k]:=nxt;
        v[k,i]:=nxt;
        gaseste:=true;
        exit;
      	end;
	gaseste:=false;
end;

procedure euristic(k: integer);
var
	i,j: integer;
  a2, b2: integer;
begin
  for i:=1 to n do
  	for j:=1 to k-1 do
	  begin
      if (v[triple[j].a,i]=0) and (v[triple[j].b,i]=0) then
      begin
        for a2:=1 to n do
        if (v[a2,triple[j].c]=0) then
	        for b2:=a2+1 to n do
	        if (v[b2,triple[j].c]=0) and (v[a2,b2]=0) then
          begin
		        v[triple[j].a,triple[j].c]:=0;
		        v[triple[j].c,triple[j].a]:=0;
		        v[triple[j].b,triple[j].c]:=0;
		        v[triple[j].c,triple[j].b]:=0;
		        v[triple[j].a,i]:=j;
		        v[i,triple[j].a]:=j;
		        v[triple[j].b,i]:=j;
		        v[i,triple[j].b]:=j;
		        v[triple[j].c,a2]:=k;
		        v[a2,triple[j].c]:=k;
		        v[triple[j].c,b2]:=k;
		        v[b2,triple[j].c]:=k;
            exit;
          	end;
      	end;
    	end;
end;

procedure scs;
var
	f: text;
  k: integer;
begin
	assign(f, fis_out);
  rewrite(f);
  writeln('YESSSS');
	writeln(f, n*(n-1) div 6);
	for k:=1 to n*(n-1) div 6 do
  begin
    writeln(f, triple[k].a, ' ', triple[k].b, ' ', triple[k].c);
  	end;
  close(f);
	halt;
end;

procedure back(k,i: integer);
var
	j,l: integer;
begin
{  if k<kmin then
  begin
    kmin:=k;
    writeln(k);
  	end;}
	if k=0 then
  begin
  	b:=true;
    exit
    end
  else
  begin
		for i:=i to n-2 do
		if xx[i]<>0 then
			for j:=i+1 to n-1 do
			if xx[j]<>0 then
      if v[i,j]=0 then
				for l:=n downto j+1 do
      	if (v[i,l]=0) and (v[j,l]=0) then
        begin
					triple[k].a:=i;
					triple[k].b:=j;
					triple[k].c:=l;
          dec(xx[i]);
          dec(xx[j]);
          dec(xx[l]);
      	  v[i,j]:=k;
	        v[j,i]:=k;
  	      v[j,l]:=k;
    	    v[l,j]:=k;
        	v[i,l]:=k;
      	  v[l,i]:=k;
          back(k-1,i);
				  if b then
				  	exit;
      	  v[i,j]:=0;
	        v[j,i]:=0;
  	      v[j,l]:=0;
    	    v[l,j]:=0;
        	v[i,l]:=0;
      	  v[l,i]:=0;
          inc(xx[i]);
          inc(xx[j]);
          inc(xx[l]);
        	end;
  	end;
end;

procedure pre_back;
var
	i: integer;
begin
	for i:=1 to n do
  	xx[i]:=n div 2;
end;

procedure imul3(vf,increm: integer);
var
	i: integer;
begin
  for i:=1 to vf do
  begin
		triple[i+vf].a:=triple[i].a+increm;
		triple[i+2*vf].a:=triple[i].a+2*increm;
		triple[i+vf].b:=triple[i].b+increm;
		triple[i+2*vf].b:=triple[i].b+2*increm;
		triple[i+vf].c:=triple[i].c+increm;
		triple[i+2*vf].c:=triple[i].c+2*increm;
  	end;
end;

procedure around3;
var
	x: array[0..33] of integer;
  i,j,k: integer;
begin
	fillchar(x, sizeof(x), 0);
  for i:=1 to n do
  begin
    inc(virf);
    triple[virf].a:=i;
    triple[virf].b:=i+n;
    triple[virf].c:=i+2*n;
  	end;
	for i:=1 to n-1 do
  begin
    j:=1;
    while (x[j]=1) or ((i+j) mod n=0) do
    	inc(j);
    x[j]:=1;
    for k:=1 to n do
    begin
      inc(virf);
      triple[virf].a:=k;
      triple[virf].b:=((k+i-1) mod n + 1) + n;
      triple[virf].c:=((k+i+j-1) mod n + 1) + 2*n;
    	end;
  	end;
end;

procedure calcul(k: integer);
var
	n2: integer;
begin
  case n of
    21, 27, 45, 81, 93: begin
    			n2:=n;
          n:=n div 3;
					calcul(n*(n-1) div 6);
          n:=n2 div 3;
          imul3(n*(n-1) div 6, n);
          virf:=n*(n-1) div 6*3;
          around3;
          end;
    else
    begin
      virf:=n*(n-1) div 6;
      pre_back;
			back(k,1);
      end;
  	end;
end;

procedure scrie;
var
	f: text;
  k: integer;
  a,b,c: integer;
begin
	assign(f, fis_out);
 	rewrite(f);
	if (n*(n-1) mod 6<>0) or (not odd(n)) then
  begin
    writeln(f, 0);
  	end
  else
  begin
    calcul(n*(n-1) div 6);
		assign(f, fis_out);
	  rewrite(f);
  	writeln('YESSSS');
		writeln(f, virf);
		for k:=1 to virf do
	  begin
  	  writeln(f, triple[k].a, ' ', triple[k].b, ' ', triple[k].c);
	  	end;
  	close(f);
		halt;
  	end;
	close(f);
end;

procedure load;
var
	f: text;
begin
	assign(f, fis_in);
  reset(f);
  readln(f, n);
  close(f);
end;

begin
{  n:=4;
  around3;}
  kmin:=100;
	load;
{  calcul;}
	scrie;
end.