program NoName;
{  uses crt,dos;}
  const MaxN=120;
  type poz=record
             aa,bb:integer;
           end;
  var a,b:array[0..MaxN] of integer;
      c:array[0..MaxN,0..MaxN] of poz;
      af,bf:array[1..MaxN] of boolean;
      n,m,i,j,h,g,cost,sw,max:integer;
      r,m1,s1,s,m2,s2:word;
      p,q:byte;
      tip:char;
      fo:text;

  procedure citeste;
    var f:text;
  begin
    assign(f,'INPUT.TXT');
    reset(f);
    readln(f,n,m);
    for i:=1 to n do
      if not seekeoln(f) then begin read(f,a[i]); af[i]:=false; end;
    readln(f);
    for i:=1 to m do
      if not seekeoln(f) then begin read(f,b[i]); bf[i]:=false; end;
    close(f);
  end;

  procedure Reconstituie(i,j:byte; lit:char);
    var gasit:boolean;
        g,h,x:byte;
  begin
    if lit='a' then af[i]:=true
               else bf[j]:=true;
     begin
           case lit of
                  'a':begin
                        gasit:=false; g:=1;
                        while (not gasit) and (g<i)do
                        begin
                          h:=1;
                          while (not gasit) and (h<j) do
                          begin
                            if (a[i]>=a[g]) and (c[g,h].aa+1=c[i,j].aa)
                            then begin
                                   Reconstituie(g,h,'a');
                                   gasit:=true;
                                 end;
                            if (a[i]>=b[h]) and (c[g,h].bb+1=c[i,j].aa) and (not gasit)
                            then begin
                                   Reconstituie(g,h,'b');
                                   gasit:=true;
                                 end;
                            inc(h);
                          end;
                          inc(g);
                        end;
                        g:=1;
                        while (not gasit) and (g<i) do
                        begin
                          if (a[i]>=a[g]) and (c[g,j].aa+1=c[i,j].aa)
                          then begin
                                 Reconstituie(g,j,'a');
                                 gasit:=true;
                               end;
                          inc(g);
                        end;
                        if not gasit
                        then if a[i]>b[j]
                             then if c[i,j].aa=c[i,j].bb+1
                                  then begin
                                         gasit:=true;
                                         Reconstituie(i,j,'b');
                                       end
                                  else
                             else if a[i]=b[j]
                                  then begin
                                         gasit:=true;
                                         dec(c[i,j].aa);
                                         Reconstituie(i,j,'a');
                                       end;

                      end;
                  'b':begin
                        gasit:=false; g:=1;
                        while (not gasit) and (g<i) do
                        begin
                          h:=1;
                          while (not gasit) and (h<j) do
                          begin
                            if (b[j]>=b[h]) and (c[g,h].bb+1=c[i,j].bb)
                            then begin
                                   Reconstituie(g,h,'b');
                                   gasit:=true;
                                 end;
                            if (b[j]>=a[g]) and (c[g,h].aa+1=c[i,j].bb)
                            then begin
                                   Reconstituie(g,h,'a');
                                   gasit:=true;
                                 end;
                            inc(h);
                          end;
                          inc(g);
                        end;
                        h:=1;
                        while (not gasit) and (h<j) do
                        begin
                          if (b[j]>=b[h]) and (c[i,h].bb+1=c[i,j].bb)
                          then begin
                                 gasit:=true;
                                 Reconstituie(i,h,'b');
                               end;
                          inc(h);
                        end;
                        if not gasit
                        then if a[i]=b[j]
                             then begin
                                    dec(c[i,j].bb);
                                    Reconstituie(i,j,'b');
                                  end
                              else if (b[j]>a[i]) and (c[i,j].bb=c[i,j].aa+1)
                                then begin
                                       gasit:=true;
                                       Reconstituie(i,j,'a');
                                     end;
                      end;
           end;
       end;
    if lit='a'
    then  write(fo,a[i],' ')
         else write(fo,b[j],' ');
  end;

begin
  {clrscr;}
  assign(fo,'OUTPUT.TXT');rewrite(fo);
{  gettime(r,m1,s1,s);
  writeln(m1,' ',s1);}
  citeste;
  for i:=1 to n do
    for j:=1 to m do
    begin
      c[i,j].aa:=1; c[i,j].bb:=1;
      for g:=1 to i-1 do
        for h:=1 to j-1 do
        begin
          if (a[i]>=a[g]) and (c[g,h].aa+1>c[i,j].aa)
          then c[i,j].aa:=c[g,h].aa+1;
          if (a[i]>=b[h]) and (c[g,h].bb+1>c[i,j].aa)
          then c[i,j].aa:=c[g,h].bb+1;
          if (b[j]>=b[h]) and (c[g,h].bb+1>c[i,j].bb)
          then c[i,j].bb:=c[g,h].bb+1;
          if (b[j]>=a[g]) and (c[g,h].aa+1>c[i,j].bb)
          then c[i,j].bb:=c[g,h].aa+1;
        end;
      for g:=1 to i-1 do
        if (a[i]>=a[g]) and (c[g,j].aa+1>c[i,j].aa)
        then c[i,j].aa:=c[g,j].aa+1;
      for h:=1 to j-1 do
        if (b[j]>=b[h]) and (c[i,h].bb+1>c[i,j].bb)
        then c[i,j].bb:=c[i,h].bb+1;
      if a[i]>b[j]
      then if c[i,j].aa<c[i,j].bb+1
           then c[i,j].aa:=1+c[i,j].bb
           else
      else if a[i]=b[j]
           then begin inc(c[i,j].aa);inc(c[i,j].bb); end
           else if c[i,j].bb<c[i,j].aa+1
                then c[i,j].bb:=1+c[i,j].aa;
    end;
    max:=1;
  for i:=1 to n do
    for j:=1 to m do
    begin
      if max<c[i,j].aa then begin max:=c[i,j].aa; p:=i; q:=j; tip:='a'; end;
      if max<c[i,j].bb then begin max:=c[i,j].bb; p:=i; q:=j; tip:='b'; end;
    end;
{  gettime(r,m2,s2,s);
  writeln(m2,' ',s2);}
  writeln(fo,max);
  Reconstituie(p,q,tip);
  close(fo);
end.